' This class is "generated" and will be overwritten.
' Your customizations should be made in PersonalExtraSalaryRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="PersonalExtraSalaryRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="PersonalExtraSalaryTable"></see> class.
''' </remarks>
''' <seealso cref="PersonalExtraSalaryTable"></seealso>
''' <seealso cref="PersonalExtraSalaryRecord"></seealso>

<Serializable()> Public Class BasePersonalExtraSalaryRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As PersonalExtraSalaryTable = PersonalExtraSalaryTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub
	
	'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub PersonalExtraSalaryRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim PersonalExtraSalaryRec As PersonalExtraSalaryRecord = CType(sender,PersonalExtraSalaryRecord)
        Validate_Inserting()
        If Not PersonalExtraSalaryRec Is Nothing AndAlso Not PersonalExtraSalaryRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub PersonalExtraSalaryRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim PersonalExtraSalaryRec As PersonalExtraSalaryRecord = CType(sender,PersonalExtraSalaryRecord)
        Validate_Updating()
        If Not PersonalExtraSalaryRec Is Nothing AndAlso Not PersonalExtraSalaryRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub PersonalExtraSalaryRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim PersonalExtraSalaryRec As PersonalExtraSalaryRecord = CType(sender,PersonalExtraSalaryRecord)
        If Not PersonalExtraSalaryRec Is Nothing AndAlso Not PersonalExtraSalaryRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.Id field.
	''' </summary>
	Public Function GetId0Value() As ColumnValue
		Return Me.GetValue(TableUtils.Id0Column)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.Id field.
	''' </summary>
	Public Function GetId0FieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.Id0Column).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.PersonalId field.
	''' </summary>
	Public Function GetPersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.PersonalId field.
	''' </summary>
	Public Function GetPersonalIdFieldValue() As String
		Return CType(Me.GetValue(TableUtils.PersonalIdColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.PersonalId field.
	''' </summary>
	Public Sub SetPersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.PersonalId field.
	''' </summary>
	Public Sub SetPersonalIdFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.ExtraSalaryId field.
	''' </summary>
	Public Function GetExtraSalaryIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.ExtraSalaryIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.ExtraSalaryId field.
	''' </summary>
	Public Function GetExtraSalaryIdFieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.ExtraSalaryIdColumn).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.ExtraSalaryId field.
	''' </summary>
	Public Sub SetExtraSalaryIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.ExtraSalaryIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.ExtraSalaryId field.
	''' </summary>
	Public Sub SetExtraSalaryIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.ExtraSalaryIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.ExtraSalaryId field.
	''' </summary>
	Public Sub SetExtraSalaryIdFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ExtraSalaryIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.ExtraSalaryId field.
	''' </summary>
	Public Sub SetExtraSalaryIdFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ExtraSalaryIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.ExtraSalaryId field.
	''' </summary>
	Public Sub SetExtraSalaryIdFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ExtraSalaryIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.Amout field.
	''' </summary>
	Public Function GetAmoutValue() As ColumnValue
		Return Me.GetValue(TableUtils.AmoutColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.Amout field.
	''' </summary>
	Public Function GetAmoutFieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.AmoutColumn).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.Amout field.
	''' </summary>
	Public Sub SetAmoutFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.AmoutColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.Amout field.
	''' </summary>
	Public Sub SetAmoutFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.AmoutColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.Amout field.
	''' </summary>
	Public Sub SetAmoutFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.AmoutColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.Amout field.
	''' </summary>
	Public Sub SetAmoutFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.AmoutColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.Amout field.
	''' </summary>
	Public Sub SetAmoutFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.AmoutColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.StartDate field.
	''' </summary>
	Public Function GetStartDateValue() As ColumnValue
		Return Me.GetValue(TableUtils.StartDateColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.StartDate field.
	''' </summary>
	Public Function GetStartDateFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.StartDateColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.StartDate field.
	''' </summary>
	Public Sub SetStartDateFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.StartDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.StartDate field.
	''' </summary>
	Public Sub SetStartDateFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.StartDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.StartDate field.
	''' </summary>
	Public Sub SetStartDateFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.StartDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.Ref field.
	''' </summary>
	Public Function GetRef0Value() As ColumnValue
		Return Me.GetValue(TableUtils.Ref0Column)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.Ref field.
	''' </summary>
	Public Function GetRef0FieldValue() As String
		Return CType(Me.GetValue(TableUtils.Ref0Column).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.Ref field.
	''' </summary>
	Public Sub SetRef0FieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Ref0Column)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.Ref field.
	''' </summary>
	Public Sub SetRef0FieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Ref0Column)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.RefDate field.
	''' </summary>
	Public Function GetRefDateValue() As ColumnValue
		Return Me.GetValue(TableUtils.RefDateColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalExtraSalary_.RefDate field.
	''' </summary>
	Public Function GetRefDateFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.RefDateColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.RefDate field.
	''' </summary>
	Public Sub SetRefDateFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RefDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.RefDate field.
	''' </summary>
	Public Sub SetRefDateFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.RefDateColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalExtraSalary_.RefDate field.
	''' </summary>
	Public Sub SetRefDateFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RefDateColumn)
	End Sub



#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalExtraSalary_.Id field.
	''' </summary>
	Public Property Id0() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.Id0Column).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.Id0Column)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Id0Specified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Id0Column)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Id0Default() As String
        Get
            Return TableUtils.Id0Column.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalExtraSalary_.PersonalId field.
	''' </summary>
	Public Property PersonalId() As String
		Get 
			Return CType(Me.GetValue(TableUtils.PersonalIdColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PersonalIdDefault() As String
        Get
            Return TableUtils.PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalExtraSalary_.ExtraSalaryId field.
	''' </summary>
	Public Property ExtraSalaryId() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.ExtraSalaryIdColumn).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.ExtraSalaryIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property ExtraSalaryIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.ExtraSalaryIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property ExtraSalaryIdDefault() As String
        Get
            Return TableUtils.ExtraSalaryIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalExtraSalary_.Amout field.
	''' </summary>
	Public Property Amout() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.AmoutColumn).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.AmoutColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property AmoutSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.AmoutColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property AmoutDefault() As String
        Get
            Return TableUtils.AmoutColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalExtraSalary_.StartDate field.
	''' </summary>
	Public Property StartDate() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.StartDateColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.StartDateColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property StartDateSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.StartDateColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property StartDateDefault() As String
        Get
            Return TableUtils.StartDateColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalExtraSalary_.Ref field.
	''' </summary>
	Public Property Ref0() As String
		Get 
			Return CType(Me.GetValue(TableUtils.Ref0Column).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.Ref0Column)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Ref0Specified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Ref0Column)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Ref0Default() As String
        Get
            Return TableUtils.Ref0Column.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalExtraSalary_.RefDate field.
	''' </summary>
	Public Property RefDate() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.RefDateColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.RefDateColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RefDateSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RefDateColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RefDateDefault() As String
        Get
            Return TableUtils.RefDateColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
